import torch.utils.data
from main import args
import numpy as np
from syn_data_guassian import view_train,view_val,view_test,split,label_test,label_val,label_train

class Text(torch.utils.data.Dataset):

    def __init__(self, data, label, train, labeled = True):

        self.m = args.modalities
        self.labeled = labeled
        self.train = train
        if not labeled:

            if train:
                self.data = self.cons_dict(data,self.m)
                self.label = label[split:]

        else:
            if train:
                self.data = self.cons_dict(data,self.m)
                self.label = label[: split]

            else:
                self.data = self.cons_dict(data,self.m)
                self.label = label


    def __len__(self):
        return len(self.label)

    def __getitem__(self, index):

        label = self.label[index]
        data_dict = {i: self.data[i][index] for i in range(1, self.m + 1)}

        return data_dict, label

    def cons_dict(self,data,m):

        t_dict = dict()
        for i in range(m):
            if self.train:
                if self.labeled:
                    t_dict[i + 1] = data[i + 1][:split]
                else:
                    t_dict[i + 1] = data[i + 1][split:]
            else:
                t_dict[i + 1] = data[i + 1]

        return t_dict
    def update_data(self, data, label, m):

        self.label = np.concatenate((self.label, label), axis=0)
        for i in range(m):
            self.data[i+1] = np.concatenate((self.data[i+1], data[i+1]), axis=0)

class Text_MIG(torch.utils.data.Dataset):

    def __init__(self, data, label):

        self.m = args.modalities
        self.data_dict = self.cons_dict(data,self.m)
        self.label = label

    def __len__(self):
        return len(self.label)

    def __getitem__(self, index):

        label = self.label[index]
        data_dict = {i: self.data_dict[i][index] for i in range(1,self.m+1)}

        return data_dict, label

    def cons_dict(self,data,m):

        t_dict = dict()
        for i in range(m):
            t_dict[i+1] = data[i+1]
        return t_dict

    def update_data(self, data, label, m):

        self.label = np.concatenate((self.label, label), axis=0)
        for i in range(m):
            self.data_dict[i+1] = np.concatenate((self.data_dict[i+1], data[i+1]), axis=0)


T_train = Text(data = view_train,label = label_train,train= True)
T_test = Text(data = view_test,label = label_test,train= False)
T_val = Text(data = view_val,label = label_val,train= False)
U_MIG = Text_MIG(data = view_train,label = label_train)


dataloader = {'train':torch.utils.data.DataLoader(dataset = T_train, batch_size = 32),
'test':torch.utils.data.DataLoader(dataset = T_test, batch_size = 32),
'val':torch.utils.data.DataLoader(dataset = T_val, batch_size = 32),
'mig':torch.utils.data.DataLoader(dataset = U_MIG, batch_size = 32),
'vat':torch.utils.data.DataLoader(dataset = U_MIG, batch_size = 32)}
